---
title: Software Catalog
description: Datadog, the leading service for cloud-scale monitoring.
breadcrumbs: Docs > API Reference > Software Catalog
---

# Software Catalog

API to create, update, retrieve, and delete Software Catalog entities.

## Get a list of entities{% #get-a-list-of-entities %}

{% tab title="v2" %}

| Datadog site      | API endpoint                                            |
| ----------------- | ------------------------------------------------------- |
| ap1.datadoghq.com | GET https://api.ap1.datadoghq.com/api/v2/catalog/entity |
| ap2.datadoghq.com | GET https://api.ap2.datadoghq.com/api/v2/catalog/entity |
| app.datadoghq.eu  | GET https://api.datadoghq.eu/api/v2/catalog/entity      |
| app.ddog-gov.com  | GET https://api.ddog-gov.com/api/v2/catalog/entity      |
| app.datadoghq.com | GET https://api.datadoghq.com/api/v2/catalog/entity     |
| us3.datadoghq.com | GET https://api.us3.datadoghq.com/api/v2/catalog/entity |
| us5.datadoghq.com | GET https://api.us5.datadoghq.com/api/v2/catalog/entity |

### Overview

Get a list of entities from Software Catalog.

OAuth apps require the `apm_service_catalog_read` authorization [scope](https://docs.datadoghq.com/api/latest/scopes/#software-catalog) to access this endpoint.



### Arguments

#### Query Strings

| Name                     | Type    | Description                                                                                                                                                                                                                                                                                  |
| ------------------------ | ------- | -------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------- |
| page[offset]             | integer | Specific offset to use as the beginning of the returned page.                                                                                                                                                                                                                                |
| page[limit]              | integer | Maximum number of entities in the response.                                                                                                                                                                                                                                                  |
| filter[id]               | string  | Filter entities by UUID.                                                                                                                                                                                                                                                                     |
| filter[ref]              | string  | Filter entities by reference                                                                                                                                                                                                                                                                 |
| filter[name]             | string  | Filter entities by name.                                                                                                                                                                                                                                                                     |
| filter[kind]             | string  | Filter entities by kind.                                                                                                                                                                                                                                                                     |
| filter[owner]            | string  | Filter entities by owner.                                                                                                                                                                                                                                                                    |
| filter[relation][type]   | enum    | Filter entities by relation type.Allowed enum values: `RelationTypeOwns, RelationTypeOwnedBy, RelationTypeDependsOn, RelationTypeDependencyOf, RelationTypePartsOf, RelationTypeHasPart, RelationTypeOtherOwns, RelationTypeOtherOwnedBy, RelationTypeImplementedBy, RelationTypeImplements` |
| filter[exclude_snapshot] | string  | Filter entities by excluding snapshotted entities.                                                                                                                                                                                                                                           |
| include                  | enum    | Include relationship data.Allowed enum values: `schema, raw_schema, oncall, incident, relation`                                                                                                                                                                                              |
| includeDiscovered        | boolean | If true, includes discovered services from APM and USM that do not have entity definitions.                                                                                                                                                                                                  |

### Response

{% tab title="200" %}
OK
{% tab title="Model" %}
List entity response.

| Parent field     | Field                        | Type            | Description                                                                                                                                                                                                                                           |
| ---------------- | ---------------------------- | --------------- | ----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------- |
|                  | data                         | [object]        | List of entity data.                                                                                                                                                                                                                                  |
| data             | attributes                   | object          | Entity attributes.                                                                                                                                                                                                                                    |
| attributes       | apiVersion                   | string          | The API version.                                                                                                                                                                                                                                      |
| attributes       | description                  | string          | The description.                                                                                                                                                                                                                                      |
| attributes       | displayName                  | string          | The display name.                                                                                                                                                                                                                                     |
| attributes       | kind                         | string          | The kind.                                                                                                                                                                                                                                             |
| attributes       | name                         | string          | The name.                                                                                                                                                                                                                                             |
| attributes       | namespace                    | string          | The namespace.                                                                                                                                                                                                                                        |
| attributes       | owner                        | string          | The owner.                                                                                                                                                                                                                                            |
| attributes       | tags                         | [string]        | The tags.                                                                                                                                                                                                                                             |
| data             | id                           | string          | Entity ID.                                                                                                                                                                                                                                            |
| data             | meta                         | object          | Entity metadata.                                                                                                                                                                                                                                      |
| meta             | createdAt                    | string          | The creation time.                                                                                                                                                                                                                                    |
| meta             | ingestionSource              | string          | The ingestion source.                                                                                                                                                                                                                                 |
| meta             | modifiedAt                   | string          | The modification time.                                                                                                                                                                                                                                |
| meta             | origin                       | string          | The origin.                                                                                                                                                                                                                                           |
| data             | relationships                | object          | Entity relationships.                                                                                                                                                                                                                                 |
| relationships    | incidents                    | object          | Entity to incidents relationship.                                                                                                                                                                                                                     |
| incidents        | data                         | [object]        | Relationships.                                                                                                                                                                                                                                        |
| data             | id                           | string          | Associated data ID.                                                                                                                                                                                                                                   |
| data             | type                         | string          | Relationship type.                                                                                                                                                                                                                                    |
| relationships    | oncall                       | object          | Entity to oncalls relationship.                                                                                                                                                                                                                       |
| oncall           | data                         | [object]        | Relationships.                                                                                                                                                                                                                                        |
| data             | id                           | string          | Associated data ID.                                                                                                                                                                                                                                   |
| data             | type                         | string          | Relationship type.                                                                                                                                                                                                                                    |
| relationships    | rawSchema                    | object          | Entity to raw schema relationship.                                                                                                                                                                                                                    |
| rawSchema        | data                         | object          | Relationship entry.                                                                                                                                                                                                                                   |
| data             | id                           | string          | Associated data ID.                                                                                                                                                                                                                                   |
| data             | type                         | string          | Relationship type.                                                                                                                                                                                                                                    |
| relationships    | relatedEntities              | object          | Entity to related entities relationship.                                                                                                                                                                                                              |
| relatedEntities  | data                         | [object]        | Relationships.                                                                                                                                                                                                                                        |
| data             | id                           | string          | Associated data ID.                                                                                                                                                                                                                                   |
| data             | type                         | string          | Relationship type.                                                                                                                                                                                                                                    |
| relationships    | schema                       | object          | Entity to detail schema relationship.                                                                                                                                                                                                                 |
| schema           | data                         | object          | Relationship entry.                                                                                                                                                                                                                                   |
| data             | id                           | string          | Associated data ID.                                                                                                                                                                                                                                   |
| data             | type                         | string          | Relationship type.                                                                                                                                                                                                                                    |
| data             | type                         | string          | Entity.                                                                                                                                                                                                                                               |
|                  | included                     | [ <oneOf>] | List entity response included.                                                                                                                                                                                                                        |
| included         | Option 1                     | object          | Included detail entity schema.                                                                                                                                                                                                                        |
| Option 1         | attributes                   | object          | Included schema.                                                                                                                                                                                                                                      |
| attributes       | schema                       |  <oneOf>   | Entity schema v3.                                                                                                                                                                                                                                     |
| schema           | Option 1                     | object          | Schema for service entities.                                                                                                                                                                                                                          |
| Option 1         | apiVersion [*required*] | enum            | The version of the schema data that was used to populate this entity's data. This could be via the API, Terraform, or YAML file in a repository. The field is known as schema-version in the previous version. Allowed enum values: `v3,v2.2,v2.1,v2` |
| Option 1         | datadog                      | object          | Datadog product integrations for the service entity.                                                                                                                                                                                                  |
| datadog          | codeLocations                | [object]        | Schema for mapping source code locations to an entity.                                                                                                                                                                                                |
| codeLocations    | paths                        | [string]        | The paths (glob) to the source code of the service.                                                                                                                                                                                                   |
| codeLocations    | repositoryURL                | string          | The repository path of the source code of the entity.                                                                                                                                                                                                 |
| datadog          | events                       | [object]        | Events associations.                                                                                                                                                                                                                                  |
| events           | name                         | string          | The name of the query.                                                                                                                                                                                                                                |
| events           | query                        | string          | The query to run.                                                                                                                                                                                                                                     |
| datadog          | logs                         | [object]        | Logs association.                                                                                                                                                                                                                                     |
| logs             | name                         | string          | The name of the query.                                                                                                                                                                                                                                |
| logs             | query                        | string          | The query to run.                                                                                                                                                                                                                                     |
| datadog          | performanceData              | object          | Performance stats association.                                                                                                                                                                                                                        |
| performanceData  | tags                         | [string]        | A list of APM entity tags that associates the APM Stats data with the entity.                                                                                                                                                                         |
| datadog          | pipelines                    | object          | CI Pipelines association.                                                                                                                                                                                                                             |
| pipelines        | fingerprints                 | [string]        | A list of CI Fingerprints that associate CI Pipelines with the entity.                                                                                                                                                                                |
| Option 1         | extensions                   | object          | Custom extensions. This is the free-formed field to send client-side metadata. No Datadog features are affected by this field.                                                                                                                        |
| Option 1         | integrations                 | object          | A base schema for defining third-party integrations.                                                                                                                                                                                                  |
| integrations     | opsgenie                     | object          | An Opsgenie integration schema.                                                                                                                                                                                                                       |
| opsgenie         | region                       | string          | The region for the Opsgenie integration.                                                                                                                                                                                                              |
| opsgenie         | serviceURL [*required*] | string          | The service URL for the Opsgenie integration.                                                                                                                                                                                                         |
| integrations     | pagerduty                    | object          | A PagerDuty integration schema.                                                                                                                                                                                                                       |
| pagerduty        | serviceURL [*required*] | string          | The service URL for the PagerDuty integration.                                                                                                                                                                                                        |
| Option 1         | kind [*required*]       | enum            | The definition of Entity V3 Service Kind object. Allowed enum values: `service`                                                                                                                                                                       |
| Option 1         | metadata [*required*]   | object          | The definition of Entity V3 Metadata object.                                                                                                                                                                                                          |
| metadata         | additionalOwners             | [object]        | The additional owners of the entity, usually a team.                                                                                                                                                                                                  |
| additionalOwners | name [*required*]       | string          | Team name.                                                                                                                                                                                                                                            |
| additionalOwners | type                         | string          | Team type.                                                                                                                                                                                                                                            |
| metadata         | contacts                     | [object]        | A list of contacts for the entity.                                                                                                                                                                                                                    |
| contacts         | contact [*required*]    | string          | Contact value.                                                                                                                                                                                                                                        |
| contacts         | name                         | string          | Contact name.                                                                                                                                                                                                                                         |
| contacts         | type [*required*]       | string          | Contact type.                                                                                                                                                                                                                                         |
| metadata         | description                  | string          | Short description of the entity. The UI can leverage the description for display.                                                                                                                                                                     |
| metadata         | displayName                  | string          | User friendly name of the entity. The UI can leverage the display name for display.                                                                                                                                                                   |
| metadata         | id                           | string          | A read-only globally unique identifier for the entity generated by Datadog. User supplied values are ignored.                                                                                                                                         |
| metadata         | inheritFrom                  | string          | The entity reference from which to inherit metadata                                                                                                                                                                                                   |
| metadata         | links                        | [object]        | A list of links for the entity.                                                                                                                                                                                                                       |
| links            | name [*required*]       | string          | Link name.                                                                                                                                                                                                                                            |
| links            | provider                     | string          | Link provider.                                                                                                                                                                                                                                        |
| links            | type [*required*]       | string          | Link type.                                                                                                                                                                                                                                            |
| links            | url [*required*]        | string          | Link URL.                                                                                                                                                                                                                                             |
| metadata         | managed                      | object          | A read-only set of Datadog managed attributes generated by Datadog. User supplied values are ignored.                                                                                                                                                 |
| metadata         | name [*required*]       | string          | Unique name given to an entity under the kind/namespace.                                                                                                                                                                                              |
| metadata         | namespace                    | string          | Namespace is a part of unique identifier. It has a default value of 'default'.                                                                                                                                                                        |
| metadata         | owner                        | string          | The owner of the entity, usually a team.                                                                                                                                                                                                              |
| metadata         | tags                         | [string]        | A set of custom tags.                                                                                                                                                                                                                                 |
| Option 1         | spec                         | object          | The definition of Entity V3 Service Spec object.                                                                                                                                                                                                      |
| spec             | componentOf                  | [string]        | A list of components the service is a part of                                                                                                                                                                                                         |
| spec             | dependsOn                    | [string]        | A list of components the service depends on.                                                                                                                                                                                                          |
| spec             | languages                    | [string]        | The service's programming language.                                                                                                                                                                                                                   |
| spec             | lifecycle                    | string          | The lifecycle state of the component.                                                                                                                                                                                                                 |
| spec             | tier                         | string          | The importance of the component.                                                                                                                                                                                                                      |
| spec             | type                         | string          | The type of service.                                                                                                                                                                                                                                  |
| schema           | Option 2                     | object          | Schema for datastore entities.                                                                                                                                                                                                                        |
| Option 2         | apiVersion [*required*] | enum            | The version of the schema data that was used to populate this entity's data. This could be via the API, Terraform, or YAML file in a repository. The field is known as schema-version in the previous version. Allowed enum values: `v3,v2.2,v2.1,v2` |
| Option 2         | datadog                      | object          | Datadog product integrations for the datastore entity.                                                                                                                                                                                                |
| datadog          | events                       | [object]        | Events associations.                                                                                                                                                                                                                                  |
| events           | name                         | string          | The name of the query.                                                                                                                                                                                                                                |
| events           | query                        | string          | The query to run.                                                                                                                                                                                                                                     |
| datadog          | logs                         | [object]        | Logs association.                                                                                                                                                                                                                                     |
| logs             | name                         | string          | The name of the query.                                                                                                                                                                                                                                |
| logs             | query                        | string          | The query to run.                                                                                                                                                                                                                                     |
| datadog          | performanceData              | object          | Performance stats association.                                                                                                                                                                                                                        |
| performanceData  | tags                         | [string]        | A list of APM entity tags that associates the APM Stats data with the entity.                                                                                                                                                                         |
| Option 2         | extensions                   | object          | Custom extensions. This is the free-formed field to send client side metadata. No Datadog features are affected by this field.                                                                                                                        |
| Option 2         | integrations                 | object          | A base schema for defining third-party integrations.                                                                                                                                                                                                  |
| integrations     | opsgenie                     | object          | An Opsgenie integration schema.                                                                                                                                                                                                                       |
| opsgenie         | region                       | string          | The region for the Opsgenie integration.                                                                                                                                                                                                              |
| opsgenie         | serviceURL [*required*] | string          | The service URL for the Opsgenie integration.                                                                                                                                                                                                         |
| integrations     | pagerduty                    | object          | A PagerDuty integration schema.                                                                                                                                                                                                                       |
| pagerduty        | serviceURL [*required*] | string          | The service URL for the PagerDuty integration.                                                                                                                                                                                                        |
| Option 2         | kind [*required*]       | enum            | The definition of Entity V3 Datastore Kind object. Allowed enum values: `datastore`                                                                                                                                                                   |
| Option 2         | metadata [*required*]   | object          | The definition of Entity V3 Metadata object.                                                                                                                                                                                                          |
| metadata         | additionalOwners             | [object]        | The additional owners of the entity, usually a team.                                                                                                                                                                                                  |
| additionalOwners | name [*required*]       | string          | Team name.                                                                                                                                                                                                                                            |
| additionalOwners | type                         | string          | Team type.                                                                                                                                                                                                                                            |
| metadata         | contacts                     | [object]        | A list of contacts for the entity.                                                                                                                                                                                                                    |
| contacts         | contact [*required*]    | string          | Contact value.                                                                                                                                                                                                                                        |
| contacts         | name                         | string          | Contact name.                                                                                                                                                                                                                                         |
| contacts         | type [*required*]       | string          | Contact type.                                                                                                                                                                                                                                         |
| metadata         | description                  | string          | Short description of the entity. The UI can leverage the description for display.                                                                                                                                                                     |
| metadata         | displayName                  | string          | User friendly name of the entity. The UI can leverage the display name for display.                                                                                                                                                                   |
| metadata         | id                           | string          | A read-only globally unique identifier for the entity generated by Datadog. User supplied values are ignored.                                                                                                                                         |
| metadata         | inheritFrom                  | string          | The entity reference from which to inherit metadata                                                                                                                                                                                                   |
| metadata         | links                        | [object]        | A list of links for the entity.                                                                                                                                                                                                                       |
| links            | name [*required*]       | string          | Link name.                                                                                                                                                                                                                                            |
| links            | provider                     | string          | Link provider.                                                                                                                                                                                                                                        |
| links            | type [*required*]       | string          | Link type.                                                                                                                                                                                                                                            |
| links            | url [*required*]        | string          | Link URL.                                                                                                                                                                                                                                             |
| metadata         | managed                      | object          | A read-only set of Datadog managed attributes generated by Datadog. User supplied values are ignored.                                                                                                                                                 |
| metadata         | name [*required*]       | string          | Unique name given to an entity under the kind/namespace.                                                                                                                                                                                              |
| metadata         | namespace                    | string          | Namespace is a part of unique identifier. It has a default value of 'default'.                                                                                                                                                                        |
| metadata         | owner                        | string          | The owner of the entity, usually a team.                                                                                                                                                                                                              |
| metadata         | tags                         | [string]        | A set of custom tags.                                                                                                                                                                                                                                 |
| Option 2         | spec                         | object          | The definition of Entity V3 Datastore Spec object.                                                                                                                                                                                                    |
| spec             | componentOf                  | [string]        | A list of components the datastore is a part of                                                                                                                                                                                                       |
| spec             | lifecycle                    | string          | The lifecycle state of the datastore.                                                                                                                                                                                                                 |
| spec             | tier                         | string          | The importance of the datastore.                                                                                                                                                                                                                      |
| spec             | type                         | string          | The type of datastore.                                                                                                                                                                                                                                |
| schema           | Option 3                     | object          | Schema for queue entities.                                                                                                                                                                                                                            |
| Option 3         | apiVersion [*required*] | enum            | The version of the schema data that was used to populate this entity's data. This could be via the API, Terraform, or YAML file in a repository. The field is known as schema-version in the previous version. Allowed enum values: `v3,v2.2,v2.1,v2` |
| Option 3         | datadog                      | object          | Datadog product integrations for the datastore entity.                                                                                                                                                                                                |
| datadog          | events                       | [object]        | Events associations.                                                                                                                                                                                                                                  |
| events           | name                         | string          | The name of the query.                                                                                                                                                                                                                                |
| events           | query                        | string          | The query to run.                                                                                                                                                                                                                                     |
| datadog          | logs                         | [object]        | Logs association.                                                                                                                                                                                                                                     |
| logs             | name                         | string          | The name of the query.                                                                                                                                                                                                                                |
| logs             | query                        | string          | The query to run.                                                                                                                                                                                                                                     |
| datadog          | performanceData              | object          | Performance stats association.                                                                                                                                                                                                                        |
| performanceData  | tags                         | [string]        | A list of APM entity tags that associates the APM Stats data with the entity.                                                                                                                                                                         |
| Option 3         | extensions                   | object          | Custom extensions. This is the free-formed field to send client-side metadata. No Datadog features are affected by this field.                                                                                                                        |
| Option 3         | integrations                 | object          | A base schema for defining third-party integrations.                                                                                                                                                                                                  |
| integrations     | opsgenie                     | object          | An Opsgenie integration schema.                                                                                                                                                                                                                       |
| opsgenie         | region                       | string          | The region for the Opsgenie integration.                                                                                                                                                                                                              |
| opsgenie         | serviceURL [*required*] | string          | The service URL for the Opsgenie integration.                                                                                                                                                                                                         |
| integrations     | pagerduty                    | object          | A PagerDuty integration schema.                                                                                                                                                                                                                       |
| pagerduty        | serviceURL [*required*] | string          | The service URL for the PagerDuty integration.                                                                                                                                                                                                        |
| Option 3         | kind [*required*]       | enum            | The definition of Entity V3 Queue Kind object. Allowed enum values: `queue`                                                                                                                                                                           |
| Option 3         | metadata [*required*]   | object          | The definition of Entity V3 Metadata object.                                                                                                                                                                                                          |
| metadata         | additionalOwners             | [object]        | The additional owners of the entity, usually a team.                                                                                                                                                                                                  |
| additionalOwners | name [*required*]       | string          | Team name.                                                                                                                                                                                                                                            |
| additionalOwners | type                         | string          | Team type.                                                                                                                                                                                                                                            |
| metadata         | contacts                     | [object]        | A list of contacts for the entity.                                                                                                                                                                                                                    |
| contacts         | contact [*required*]    | string          | Contact value.                                                                                                                                                                                                                                        |
| contacts         | name                         | string          | Contact name.                                                                                                                                                                                                                                         |
| contacts         | type [*required*]       | string          | Contact type.                                                                                                                                                                                                                                         |
| metadata         | description                  | string          | Short description of the entity. The UI can leverage the description for display.                                                                                                                                                                     |
| metadata         | displayName                  | string          | User friendly name of the entity. The UI can leverage the display name for display.                                                                                                                                                                   |
| metadata         | id                           | string          | A read-only globally unique identifier for the entity generated by Datadog. User supplied values are ignored.                                                                                                                                         |
| metadata         | inheritFrom                  | string          | The entity reference from which to inherit metadata                                                                                                                                                                                                   |
| metadata         | links                        | [object]        | A list of links for the entity.                                                                                                                                                                                                                       |
| links            | name [*required*]       | string          | Link name.                                                                                                                                                                                                                                            |
| links            | provider                     | string          | Link provider.                                                                                                                                                                                                                                        |
| links            | type [*required*]       | string          | Link type.                                                                                                                                                                                                                                            |
| links            | url [*required*]        | string          | Link URL.                                                                                                                                                                                                                                             |
| metadata         | managed                      | object          | A read-only set of Datadog managed attributes generated by Datadog. User supplied values are ignored.                                                                                                                                                 |
| metadata         | name [*required*]       | string          | Unique name given to an entity under the kind/namespace.                                                                                                                                                                                              |
| metadata         | namespace                    | string          | Namespace is a part of unique identifier. It has a default value of 'default'.                                                                                                                                                                        |
| metadata         | owner                        | string          | The owner of the entity, usually a team.                                                                                                                                                                                                              |
| metadata         | tags                         | [string]        | A set of custom tags.                                                                                                                                                                                                                                 |
| Option 3         | spec                         | object          | The definition of Entity V3 Queue Spec object.                                                                                                                                                                                                        |
| spec             | componentOf                  | [string]        | A list of components the queue is a part of                                                                                                                                                                                                           |
| spec             | lifecycle                    | string          | The lifecycle state of the queue.                                                                                                                                                                                                                     |
| spec             | tier                         | string          | The importance of the queue.                                                                                                                                                                                                                          |
| spec             | type                         | string          | The type of queue.                                                                                                                                                                                                                                    |
| schema           | Option 4                     | object          | Schema for system entities.                                                                                                                                                                                                                           |
| Option 4         | apiVersion [*required*] | enum            | The version of the schema data that was used to populate this entity's data. This could be via the API, Terraform, or YAML file in a repository. The field is known as schema-version in the previous version. Allowed enum values: `v3,v2.2,v2.1,v2` |
| Option 4         | datadog                      | object          | Datadog product integrations for the service entity.                                                                                                                                                                                                  |
| datadog          | events                       | [object]        | Events associations.                                                                                                                                                                                                                                  |
| events           | name                         | string          | The name of the query.                                                                                                                                                                                                                                |
| events           | query                        | string          | The query to run.                                                                                                                                                                                                                                     |
| datadog          | logs                         | [object]        | Logs association.                                                                                                                                                                                                                                     |
| logs             | name                         | string          | The name of the query.                                                                                                                                                                                                                                |
| logs             | query                        | string          | The query to run.                                                                                                                                                                                                                                     |
| datadog          | performanceData              | object          | Performance stats association.                                                                                                                                                                                                                        |
| performanceData  | tags                         | [string]        | A list of APM entity tags that associates the APM Stats data with the entity.                                                                                                                                                                         |
| datadog          | pipelines                    | object          | CI Pipelines association.                                                                                                                                                                                                                             |
| pipelines        | fingerprints                 | [string]        | A list of CI Fingerprints that associate CI Pipelines with the entity.                                                                                                                                                                                |
| Option 4         | extensions                   | object          | Custom extensions. This is the free-formed field to send client-side metadata. No Datadog features are affected by this field.                                                                                                                        |
| Option 4         | integrations                 | object          | A base schema for defining third-party integrations.                                                                                                                                                                                                  |
| integrations     | opsgenie                     | object          | An Opsgenie integration schema.                                                                                                                                                                                                                       |
| opsgenie         | region                       | string          | The region for the Opsgenie integration.                                                                                                                                                                                                              |
| opsgenie         | serviceURL [*required*] | string          | The service URL for the Opsgenie integration.                                                                                                                                                                                                         |
| integrations     | pagerduty                    | object          | A PagerDuty integration schema.                                                                                                                                                                                                                       |
| pagerduty        | serviceURL [*required*] | string          | The service URL for the PagerDuty integration.                                                                                                                                                                                                        |
| Option 4         | kind [*required*]       | enum            | The definition of Entity V3 System Kind object. Allowed enum values: `system`                                                                                                                                                                         |
| Option 4         | metadata [*required*]   | object          | The definition of Entity V3 Metadata object.                                                                                                                                                                                                          |
| metadata         | additionalOwners             | [object]        | The additional owners of the entity, usually a team.                                                                                                                                                                                                  |
| additionalOwners | name [*required*]       | string          | Team name.                                                                                                                                                                                                                                            |
| additionalOwners | type                         | string          | Team type.                                                                                                                                                                                                                                            |
| metadata         | contacts                     | [object]        | A list of contacts for the entity.                                                                                                                                                                                                                    |
| contacts         | contact [*required*]    | string          | Contact value.                                                                                                                                                                                                                                        |
| contacts         | name                         | string          | Contact name.                                                                                                                                                                                                                                         |
| contacts         | type [*required*]       | string          | Contact type.                                                                                                                                                                                                                                         |
| metadata         | description                  | string          | Short description of the entity. The UI can leverage the description for display.                                                                                                                                                                     |
| metadata         | displayName                  | string          | User friendly name of the entity. The UI can leverage the display name for display.                                                                                                                                                                   |
| metadata         | id                           | string          | A read-only globally unique identifier for the entity generated by Datadog. User supplied values are ignored.                                                                                                                                         |
| metadata         | inheritFrom                  | string          | The entity reference from which to inherit metadata                                                                                                                                                                                                   |
| metadata         | links                        | [object]        | A list of links for the entity.                                                                                                                                                                                                                       |
| links            | name [*required*]       | string          | Link name.                                                                                                                                                                                                                                            |
| links            | provider                     | string          | Link provider.                                                                                                                                                                                                                                        |
| links            | type [*required*]       | string          | Link type.                                                                                                                                                                                                                                            |
| links            | url [*required*]        | string          | Link URL.                                                                                                                                                                                                                                             |
| metadata         | managed                      | object          | A read-only set of Datadog managed attributes generated by Datadog. User supplied values are ignored.                                                                                                                                                 |
| metadata         | name [*required*]       | string          | Unique name given to an entity under the kind/namespace.                                                                                                                                                                                              |
| metadata         | namespace                    | string          | Namespace is a part of unique identifier. It has a default value of 'default'.                                                                                                                                                                        |
| metadata         | owner                        | string          | The owner of the entity, usually a team.                                                                                                                                                                                                              |
| metadata         | tags                         | [string]        | A set of custom tags.                                                                                                                                                                                                                                 |
| Option 4         | spec                         | object          | The definition of Entity V3 System Spec object.                                                                                                                                                                                                       |
| spec             | components                   | [string]        | A list of components belongs to the system.                                                                                                                                                                                                           |
| spec             | lifecycle                    | string          | The lifecycle state of the component.                                                                                                                                                                                                                 |
| spec             | tier                         | string          | An entity reference to the owner of the component.                                                                                                                                                                                                    |
| schema           | Option 5                     | object          | Schema for API entities.                                                                                                                                                                                                                              |
| Option 5         | apiVersion [*required*] | enum            | The version of the schema data that was used to populate this entity's data. This could be via the API, Terraform, or YAML file in a repository. The field is known as schema-version in the previous version. Allowed enum values: `v3,v2.2,v2.1,v2` |
| Option 5         | datadog                      | object          | Datadog product integrations for the API entity.                                                                                                                                                                                                      |
| datadog          | codeLocations                | [object]        | Schema for mapping source code locations to an entity.                                                                                                                                                                                                |
| codeLocations    | paths                        | [string]        | The paths (glob) to the source code of the service.                                                                                                                                                                                                   |
| codeLocations    | repositoryURL                | string          | The repository path of the source code of the entity.                                                                                                                                                                                                 |
| datadog          | events                       | [object]        | Events associations.                                                                                                                                                                                                                                  |
| events           | name                         | string          | The name of the query.                                                                                                                                                                                                                                |
| events           | query                        | string          | The query to run.                                                                                                                                                                                                                                     |
| datadog          | logs                         | [object]        | Logs association.                                                                                                                                                                                                                                     |
| logs             | name                         | string          | The name of the query.                                                                                                                                                                                                                                |
| logs             | query                        | string          | The query to run.                                                                                                                                                                                                                                     |
| datadog          | performanceData              | object          | Performance stats association.                                                                                                                                                                                                                        |
| performanceData  | tags                         | [string]        | A list of APM entity tags that associates the APM Stats data with the entity.                                                                                                                                                                         |
| datadog          | pipelines                    | object          | CI Pipelines association.                                                                                                                                                                                                                             |
| pipelines        | fingerprints                 | [string]        | A list of CI Fingerprints that associate CI Pipelines with the entity.                                                                                                                                                                                |
| Option 5         | extensions                   | object          | Custom extensions. This is the free-formed field to send client-side metadata. No Datadog features are affected by this field.                                                                                                                        |
| Option 5         | integrations                 | object          | A base schema for defining third-party integrations.                                                                                                                                                                                                  |
| integrations     | opsgenie                     | object          | An Opsgenie integration schema.                                                                                                                                                                                                                       |
| opsgenie         | region                       | string          | The region for the Opsgenie integration.                                                                                                                                                                                                              |
| opsgenie         | serviceURL [*required*] | string          | The service URL for the Opsgenie integration.                                                                                                                                                                                                         |
| integrations     | pagerduty                    | object          | A PagerDuty integration schema.                                                                                                                                                                                                                       |
| pagerduty        | serviceURL [*required*] | string          | The service URL for the PagerDuty integration.                                                                                                                                                                                                        |
| Option 5         | kind [*required*]       | enum            | The definition of Entity V3 API Kind object. Allowed enum values: `api`                                                                                                                                                                               |
| Option 5         | metadata [*required*]   | object          | The definition of Entity V3 Metadata object.                                                                                                                                                                                                          |
| metadata         | additionalOwners             | [object]        | The additional owners of the entity, usually a team.                                                                                                                                                                                                  |
| additionalOwners | name [*required*]       | string          | Team name.                                                                                                                                                                                                                                            |
| additionalOwners | type                         | string          | Team type.                                                                                                                                                                                                                                            |
| metadata         | contacts                     | [object]        | A list of contacts for the entity.                                                                                                                                                                                                                    |
| contacts         | contact [*required*]    | string          | Contact value.                                                                                                                                                                                                                                        |
| contacts         | name                         | string          | Contact name.                                                                                                                                                                                                                                         |
| contacts         | type [*required*]       | string          | Contact type.                                                                                                                                                                                                                                         |
| metadata         | description                  | string          | Short description of the entity. The UI can leverage the description for display.                                                                                                                                                                     |
| metadata         | displayName                  | string          | User friendly name of the entity. The UI can leverage the display name for display.                                                                                                                                                                   |
| metadata         | id                           | string          | A read-only globally unique identifier for the entity generated by Datadog. User supplied values are ignored.                                                                                                                                         |
| metadata         | inheritFrom                  | string          | The entity reference from which to inherit metadata                                                                                                                                                                                                   |
| metadata         | links                        | [object]        | A list of links for the entity.                                                                                                                                                                                                                       |
| links            | name [*required*]       | string          | Link name.                                                                                                                                                                                                                                            |
| links            | provider                     | string          | Link provider.                                                                                                                                                                                                                                        |
| links            | type [*required*]       | string          | Link type.                                                                                                                                                                                                                                            |
| links            | url [*required*]        | string          | Link URL.                                                                                                                                                                                                                                             |
| metadata         | managed                      | object          | A read-only set of Datadog managed attributes generated by Datadog. User supplied values are ignored.                                                                                                                                                 |
| metadata         | name [*required*]       | string          | Unique name given to an entity under the kind/namespace.                                                                                                                                                                                              |
| metadata         | namespace                    | string          | Namespace is a part of unique identifier. It has a default value of 'default'.                                                                                                                                                                        |
| metadata         | owner                        | string          | The owner of the entity, usually a team.                                                                                                                                                                                                              |
| metadata         | tags                         | [string]        | A set of custom tags.                                                                                                                                                                                                                                 |
| Option 5         | spec                         | object          | The definition of Entity V3 API Spec object.                                                                                                                                                                                                          |
| spec             | implementedBy                | [string]        | Services which implemented the API.                                                                                                                                                                                                                   |
| spec             | interface                    |  <oneOf>   | The API definition.                                                                                                                                                                                                                                   |
| spec             | lifecycle                    | string          | The lifecycle state of the component.                                                                                                                                                                                                                 |
| spec             | tier                         | string          | The importance of the component.                                                                                                                                                                                                                      |
| spec             | type                         | string          | The type of API.                                                                                                                                                                                                                                      |
| Option 1         | id                           | string          | Entity ID.                                                                                                                                                                                                                                            |
| Option 1         | type                         | enum            | Schema type. Allowed enum values: `schema`                                                                                                                                                                                                            |
| included         | Option 2                     | object          | Included raw schema.                                                                                                                                                                                                                                  |
| Option 2         | attributes                   | object          | Included raw schema attributes.                                                                                                                                                                                                                       |
| attributes       | rawSchema                    | string          | Schema from user input in base64 encoding.                                                                                                                                                                                                            |
| Option 2         | id                           | string          | Raw schema ID.                                                                                                                                                                                                                                        |
| Option 2         | type                         | enum            | Raw schema type. Allowed enum values: `rawSchema`                                                                                                                                                                                                     |
| included         | Option 3                     | object          | Included related entity.                                                                                                                                                                                                                              |
| Option 3         | attributes                   | object          | Related entity attributes.                                                                                                                                                                                                                            |
[...]
